/****************************ch563TFTPӿں*****************************/


/***************************************************************************/
/* ͷļ*/
#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include "CH563BAS.H"
#include "CH563NET.H"
#include "TFTP.H"
#include "ISPXT56X.H"
/***************************************************************************/
/*  */
char   *downfile="CH563.BIN";                                                   //ļ                     
char   *trmode="octet";                                                         //ļʽ               
char   *option="tsize";                                                         //ѡļС         
UINT8  desip[4];                                                                //tftpip               
UINT8  ReqBuffer[50];                                                           //ڱ             
UINT8  ACKBuffer[20];                                                           //ڱACK              
UINT8  DATABuffer[600];                                                         //ڱݰ             
UINT16 datasize ;                                                               //ļ                   
UINT8  errorcode;                                                               //                     
UINT8  opcode;                                                                  //ݰ               
UINT16 block_num;                                                               //ݰ                 
UINT16 sendport;                                                                //ݴ˿               
                                                      
/*************************************************************************
ܣװͻ

룺filenameļ
      optionļСѡ
     
      
װɺĳ
**************************************************************************/

UINT8 Create_Request_Package(const char *filename )
{
   UINT16 i=0;
   UINT16 pos=0;

   memset(ReqBuffer,0,50);
   ReqBuffer[pos]=0;
    pos++;
   ReqBuffer[pos]=TFTP_RRQ;                                                     //ļ
    pos++;
   for(i=0;i<strlen(filename);i++){                                             //ļ        
      ReqBuffer[pos]=filename[i];
      pos++;
   }
      ReqBuffer[pos]=0;
      pos++;        
   for(i=0;i<strlen(trmode);i++){                                               //ļ䷽ʽĬoctet        
      ReqBuffer[pos]=trmode[i];
       pos++;
   }
      ReqBuffer[pos]=0;
       pos++;        
    for(i=0;i<strlen(option);i++){                                               //ѡļСtsize        
      ReqBuffer[pos]=option[i];
       pos++;
   }
      ReqBuffer[pos]=0;
       pos++;        
      ReqBuffer[pos]='0';
       pos++;        
      ReqBuffer[pos]=0;
       pos++;
        
    return pos;                                                                 //ĵĳȡ
        
}

/*************************************************************************
ܣװͻACK

룺block_num:ݰ
      
װɺACKĳ
**************************************************************************/
UINT8 Create_Ack_Package(UINT16 block_num)
{
      UINT8 pos=0;
  
      memset(ACKBuffer,0,20);
      ACKBuffer[pos]=0;
       pos++;
      ACKBuffer[pos]=TFTP_ACK;                                                  //Ϊack
       pos++;
      ACKBuffer[pos]=(char)(block_num>>8);                                      //
       pos++;
      ACKBuffer[pos]=(char)(block_num);
       pos++;
      
      return pos;  
}
  
/*************************************************************************
ܣװͻdata

룺block_num:ݰ
      datasize:һݵĳ
       
װɺdataĳ
**************************************************************************/
UINT16 Create_Data_Package(UINT16 block_num,UINT16 datasize,char *sendbuf)
{
      UINT16 sendlen;                                                           //ݳȣ512
      UINT16 pos=0;
  
      memset(DATABuffer,0,600);
      DATABuffer[pos]=0;
       pos++;
      DATABuffer[pos]=TFTP_DATA;                                                //Ϊݰ
       pos++;
      DATABuffer[pos]=(char)(block_num>>8);                                     //
       pos++;
      DATABuffer[pos]=(char)(block_num);
       pos++;
      if(datasize>=512)
       sendlen=512;
      else 
       sendlen=datasize;
      memcpy(&DATABuffer[pos],sendbuf,sendlen);
       pos+=sendlen;
      
      return pos;
  
}

/*************************************************************************
ܣյݰ

:  opcode:հ
       block_num:
             
װɺdataĳ
**************************************************************************/
void Parse_Recv_Package(UINT8 *buf)
{
  UINT32 len;
  UINT8 i;
  switch(buf[1])                                                                //հĲ(ͣ
  {
    
    case TFTP_DATA: 
          opcode=TFTP_DATA; 
          block_num=buf[3];                                                     //յݰȡݰ                    
          len=Create_Ack_Package(block_num);
          CH563NET_SocketUdpSendTo(0,ACKBuffer,&len,desip,sendport);            //Ӧŵack            
          break;
    case TFTP_ACK:  
          opcode=TFTP_DATA;
          block_num=buf[3];                                                     //յACKȡݰ        
          break;    
    case TFTP_ERROR:
          opcode=5;
          errorcode=buf[3];                                                     //յȡ 
          printf("error:%d\n",errorcode);
          break;    
    case TFTP_OACK:
          opcode=TFTP_OACK;                                                     //յOACK          
          block_num=buf[3];                                        
          CH56X_FlashLock( 0x00 );                                              // FLASH
          i = CH56X_FlashErase( flash_addr ,1024*64 );                          //flash 
          if( i ){
            printf("    ***Erase Error***\n");
          }
else              printf("    ***Erase ok***\n");
	
          len=Create_Ack_Package(0);                        
          CH563NET_SocketUdpSendTo(0,ACKBuffer,&len,desip,sendport);            //յoack󣬷ͱΪ0ACK            
          break;              
    default:  
          break;
  }      
}  

      
  
    
  
  
  
   
  
  
  
  
  
  
  

