#ifndef __TCP_CLIENT_H
#define __TCP_CLIENT_H

#include "debug.h"
#include "CH563NET.H"
#include "ISPXT56X.H"

extern UINT8 MACAddr[6];                             /* CH563MACַ */
extern UINT8 IPAddr[4];                                          /* CH563IPַ */
extern UINT8 GWIPAddr[4];                                        /* CH563 */
extern UINT8 IPMask[4];                                        /* CH563 */

extern UINT32 *length;
extern UINT32 len1;
//extern UINT8 flag;
extern UINT8 MyBuf[1600];  

void SysTimeInit( void );
void InitSysHal(void);
void mStopIfError(UINT8 iError);
UINT8 CH563NET_LibInit(const UINT8 *ip,const UINT8 *gwip,const UINT8 *mask,const UINT8 *macaddr);
void CH563NET_HandleSockInt(UINT8 sockeid,UINT8 initstat);
void CH563NET_HandleGlobalInt(void);
UINT32 RX_Check_Sum(UINT8* buf , UINT16 length);

#endif
