#ifndef _MAIN_H
#define _MAIN_H


#include "Debug.h"

#include "ch563_gpio.h"
#include "TCP_Client.h"


#include "CH563NET.H"
#include "ISPXT56X.H"

extern UINT8 update_socketid;
extern UINT16 app_version;                                                                     //汾
extern UINT32 bin_length;  
typedef struct _NET_INF
{                                                       
    UINT8  ip_add[4];      
		UINT8  gwip_add[4];
	  UINT8  mask_add[4];
    UINT32	dest_port;
	  UINT32	local_port;
}NET_INF;

#define bin_bufsize 4096

typedef struct _bin_struct
{                                                       
    UINT8  buf[bin_bufsize]; 
    UINT16 p_recv;
    UINT16 p_send;
    UINT16 remain_len;	

}bin_struct;


extern  NET_INF   net_info;
extern bin_struct bin; 
extern enum UART_CMD Uart_Cmd_enum;

extern UINT8 Tcpdesip[4];
extern UINT16 Tcpdesport;
extern UINT16 Tcpsrcport;
extern UINT8 update_flag;
extern UINT32 bin_addr;
extern UINT32 tlen;

void CH563NET_CreatTcpSocket(void);
void Writebin_to_Flash(void);
#endif
